unit ViewFormu;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, Vcl.DBCtrls,
  Vcl.Grids, Vcl.DBGrids, Data.DB;

type
  TViewForm = class(TForm)
    ViewMemo: TMemo;
    ViewGrid: TDBGrid;
    ViewNavigator: TDBNavigator;
    ViewDataSource: TDataSource;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure Initialize(DataSet: TDataSet);
  end;

var
  ViewForm: TViewForm;

implementation

{$R *.dfm}

{ TViewForm }

procedure TViewForm.Button1Click(Sender: TObject);
begin
  Self.Close;
end;

procedure TViewForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if not (fsModal in FormState) then
    Action := caFree;
end;

procedure TViewForm.Initialize(DataSet: TDataSet);
begin
  ViewMemo.Visible := DataSet = nil;
  ViewGrid.Visible := not ViewMemo.Visible;
  ViewNavigator.Visible := not ViewMemo.Visible;
  if ViewGrid.Visible then
    ViewDataSource.DataSet := DataSet;
end;

end.
