unit MainFormu;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, FireDAC.Stan.Intf, FireDAC.Stan.Option,
  FireDAC.Stan.Param, FireDAC.Stan.Error, FireDAC.DatS, FireDAC.Phys.Intf,
  FireDAC.DApt.Intf, Vcl.ExtCtrls, Vcl.DBCtrls, Data.DB, Vcl.Grids, Vcl.DBGrids,
  Vcl.StdCtrls, FireDAC.Comp.DataSet, FireDAC.Comp.Client, Datasnap.DBClient,
  Vcl.ComCtrls, Datasnap.Provider, FireDAC.Stan.Async, FireDAC.DApt,
  FireDAC.Stan.StorageBin;

type
  TForm1 = class(TForm)
    CustomerClientDataSet: TClientDataSet;
    CustomerFDMemTable: TFDMemTable;
    DataSource1: TDataSource;
    CustomerProvider: TDataSetProvider;
    RadioGroup: TRadioGroup;
    DBNavigator1: TDBNavigator;
    DBGrid1: TDBGrid;
    CustomerQuery: TFDQuery;
    OrdersQuery: TFDQuery;
    CustomerQuery2: TFDQuery;
    OrdersQuery2: TFDQuery;
    CustomerSource: TDataSource;
    CustomerSource2: TDataSource;
    DBNavigator2: TDBNavigator;
    DBGrid2: TDBGrid;
    DataSource2: TDataSource;
    OpenCloseBtn: TButton;
    OrdersClientDataSet: TClientDataSet;
    FDSchemaAdapter1: TFDSchemaAdapter;
    CustomerClientDataSetCUSTNO: TFloatField;
    CustomerClientDataSetCOMPANY: TStringField;
    CustomerClientDataSetADDR1: TStringField;
    CustomerClientDataSetADDR2: TStringField;
    CustomerClientDataSetCITY: TStringField;
    CustomerClientDataSetSTATE: TStringField;
    CustomerClientDataSetZIP: TStringField;
    CustomerClientDataSetCOUNTRY: TStringField;
    CustomerClientDataSetPHONE: TStringField;
    CustomerClientDataSetFAX: TStringField;
    CustomerClientDataSetTAXRATE: TFloatField;
    CustomerClientDataSetCONTACT: TStringField;
    CustomerClientDataSetLASTINVOICEDATE: TSQLTimeStampField;
    CustomerClientDataSetOrdersQuery: TDataSetField;
    procedure RadioGroupClick(Sender: TObject);
    procedure OpenCloseBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses DataModuleu, shellapi;


procedure TForm1.FormCreate(Sender: TObject);
begin
  RadioGroupClick(Sender);
end;

procedure TForm1.OpenCloseBtnClick(Sender: TObject);
begin
  if OpenCloseBtn.Caption = 'Open' then
  begin
    CustomerClientDataSet.Open;
    OrdersClientDataSet.DataSetField :=
      TDataSetField(CustomerClientDataSet.FieldByName('OrdersQuery'));
//  Now hook up the FDMemTable
    CustomerQuery.Open;
// This is one way
    CustomerFDMemTable.Data := CustomerQuery.Data;
// This is another
//    CustomerFDMemTable.CopyDataSet(CustomerQuery, [coStructure]);
//    CustomerFDMemTable.CopyDataSet(CustomerQuery);
// Here is another
//    CustomerFDMemTable.CloneCursor(CustomerQuery);
    CustomerQuery.Close;
    OpenCloseBtn.Caption := 'Close';
  end
  else
  begin
    CustomerClientDataSet.Close;
    CustomerFDMemTable.Close;
    OpenCloseBtn.Caption := 'Open';
  end;
end;

procedure TForm1.RadioGroupClick(Sender: TObject);
begin
  case RadioGroup.ItemIndex of
    0:
    begin
      DataSource1.DataSet := CustomerClientDataSet;
      DataSource2.DataSet := OrdersClientDataSet;
    end;
    1:
    begin
      DataSource1.DataSet := CustomerFDMemTable;
      DataSource2.DataSet := nil;
    end;
  end;
end;

end.
